import * as React from "react";
import useResizeObserver from '@react-hook/resize-observer';
//import ResizeObserver from "resize-observer-polyfill";
/* 新的包 @react-hook/resize-observer 接替本hook;
注意：注入Spring动画时 const width= useMeasure(containerRef)?.width | 0;  避免报错NaN;
【非常严重问题】const printing = useMediaLayout('print');是行不通的！获得值不能作为逻辑依据。因为触发切换true时机不对。必须依赖css才能确保正确逻辑。
* */
export const useMeasure = (target) => {
    //打印切换时刻：size刚开始会遗留屏幕上面的div宽度(状态 size 遗留？)。然后才会正常的纸张的宽度！！ 【问题】！！
    //要等到下一次render: 再次运行到了seResizeObserver001= true才能获取到正常的宽度！
    //必须在 printing转true的第一时间用getBoundingClientRect()返回取值；
    //useResizeObserver（）实际上在打印整个过程都没有触发事件的！useResizeObserver只对屏幕翻转大小拖拉才会触发的和打印无关。
    const [size, setSize] = React.useState();
    //【浏览器打印按钮】点击后出现true最后还有false;前面是真的打印预览，后面是屏幕也会更新重绘。 打印需要单独增加setSize切换指令！感觉用 useMedia 对打印切换情形不友好？ useMediaLayout
    // const printing = useMediaLayout('print');
    useResizeObserver(target, (entry) => {
        // console.log("底层resize-observer触发i" ,printing, entry);
        setSize(entry.contentRect);
    });
    // console.log("底层resize-触发=" , target?.current?.getBoundingClientRect(), target?.current);
    if (target === null || target?.current === null)
        return undefined;
    else
        return target?.current.getBoundingClientRect();
    //不能使用else  return size;来返回： 打印时刻这么做都是滞后的宽度值，并非最新的宽度数值。
};
//export function useMeasure(ref: React.MutableRefObject<any>) {  return { bounds };
//【问题】使用useMedia；useMediaLayout('print') "react-responsive"包的useMediaQuery({query: 'print'})来判定打印很不靠谱；应该用css={{}}来做。
//# sourceMappingURL=use-measure.js.map